/*
 * This file is a component of thundr, a software library from 3wks.
 * Read more: http://www.3wks.com.au/thundr
 * Copyright (C) 2013 3wks, <thundr@3wks.com.au>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.threewks.thundr.view.handlebars;

import org.apache.commons.lang3.StringUtils;

import com.github.jknack.handlebars.Template;
import com.github.jknack.handlebars.cache.ConcurrentMapCache;

public class ReloadingConcurrentMapCache extends ConcurrentMapCache {
	@Override
	public Template get(Object key) {
		return super.get(rekey(key));
	}

	@Override
	public void put(Object key, Template template) {
		super.put(rekey(key), template);
	}

	@Override
	public void clear() {
		super.clear();
	}

	@Override
	public void evict(Object key) {
		super.evict(rekey(key));
	}

	String rekey(Object key) {
		return StringUtils.substringBefore(key.toString(), "@");
	}
}
